$code-font-family: "Droid Sans Mono", "DejaVu Sans Mono", monospace;
$code-font-size:  0.95rem;
$code-font-weight: normal;
$code-line-height: 1.45;
$code-color: rgba(0,0,0,0.9);
$code-bg-color: #f7f7f8;
$code-padding: 0.1em 0.5ex;
$code-word-spacing: -0.15em;
$code-text-rendering: optimizeSpeed;

$pre-font-family: "Droid Sans Mono", "DejaVu Sans Mono", "Monospace", monospace;
$pre-font-color: rgba(0,0,0,0.9);
$pre-font-size: 0.95rem;
$pre-border-size: 1px;
$pre-border-style: solid;
$pre-border-color: #cccccc;
$pre-bg: #f7f7f8;
$pre-padding: 16px;
$pre-line-height: 1.45;

$blockquote-cite-font-color: rgba(0,0,0,0.6);
$blockquote-cite-font-size: 0.95rem;

$admonition-icon-separator-border-size: 1px;


/* Forces asciidoctor embedded images not to go past the content column */

.imageblock img {
  max-width: 100%;
}

// :not([class^=L]) is for prettify; could also use :not(li)
:not(pre):not([class^=L]) > code {
    font-size: 0.95em;
    font-style: normal !important;
    letter-spacing: 0;
    padding: $code-padding;
    word-spacing: $code-word-spacing;
    background-color: $code-bg-color;
    //text-shadow: none;
    line-height: $code-line-height;
  }
  
  pre {
      color: $pre-font-color;
      font-family: $pre-font-family;
      //font-weight: $pre-font-weight;
      line-height: $pre-line-height;
      // NOTE syntax highlighters may deeply nest both code and pre tags
      code, pre {
        // QUESTION what about background?
        color: inherit;
        font-size: inherit;
        line-height: inherit;
      }
      > code {
        display: block;
      }
    }
    
  pre.nowrap,
  pre.nowrap pre {
    white-space: pre;
    //overflow-wrap: normal;
    word-wrap: normal;
  }
  
  
  .keyseq {
    color: lighten($body-color, 20%);
  }
  
  kbd {
    font-family: $code-font-family;
    display: inline-block;
    color: $body-color;
    font-size: 0.65em;
    line-height: 1.45;
    background-color: #f7f7f7;
    border: 1px solid #ccc;
    @include border-radius(3px);
    @include box-shadow(0 1px 0 rgba(0,0,0,0.2), 0 0 0 0.1em white inset);
    margin: 0 0.15em;
    padding: 0.2em 0.5em;
    vertical-align: middle;
    position: relative;
    top: -0.1em;
    white-space: nowrap;
  }
  
  .keyseq kbd:first-child {
    margin-left: 0;
  }
  
  .keyseq kbd:last-child {
    margin-right: 0;
  }
  
  .menuseq, .menuref {
    color: #000;
  }
  
  .menuseq b:not(.caret), .menuref {
    font-weight: inherit;
  }
  
  .menuseq {
    word-spacing: -0.02em;
    b.caret {
      font-size: 1.25em;
      line-height: 0.8;
    }
    i.caret {
      font-weight: bold;
      text-align: center;
      width: 0.45em;
    }
  }
  
  
  // AsciiDoc block styles
  details,
  .audioblock,
  .imageblock,
  .literalblock,
  .listingblock,
  .stemblock,
  .videoblock,
  .admonitionblock {
    margin-bottom: $spacer;
  }
  
  details > summary:first-of-type {
    cursor: pointer;
    display: list-item;
    outline: none;
    margin-bottom: 0.75em;
  }
  
  .admonitionblock td.content,
  .audioblock,
  .exampleblock,
  .imageblock,
  .listingblock,
  .literalblock,
  .stemblock,
  .openblock,
  .paragraph,
  .quoteblock,
  table.tableblock,
  .verseblock,
  .videoblock,
  .dlist,
  .olist,
  .ulist,
  .qlist,
  .hdlist {
    > .title {
      text-align: left;
    }
  }
  
.admonitionblock > table {
  padding: 1rem;
  border-collapse: separate;
  border: 0;
  background: none; // FIXME this wouldn't be required if a background was set on table.tableblock and not table
  width: 100%;
  td.icon {
    text-align: center;
    // FIXME use ems!
    width: 80px;
    img {
      max-width: none;
    }
    .title {
      //font-weight: $header-font-weight;
      font-weight: bold;
      text-transform: uppercase;
    }
  }

  td.content {
    padding-left: 1.125rem;
    padding-right: 1.25rem;
    border-left: $admonition-icon-separator-border-size solid $border-color; 
    // FIXME use $aside-font-color
    color: $blockquote-cite-font-color;
    // QUESTION use opacity instead of blockquote-cite-font-color?
    //opacity: 0.75;
    word-wrap: anywhere;

    //> .paragraph:last-child > p {
    > :last-child > :last-child {
      margin-bottom: 0;
    }
  }
}
  
.admonitionblock.warning {
  color: #8a6d3b;
  background-color: #ffd3d3;
  border-color: #faebcc
}

.admonitionblock.caution,
.admonitionblock.important {
  color: #8a6d3b;
  background-color: #fcf8e3;
  border-color: #faebcc
}

.admonitionblock.tip,
.admonitionblock.note {
  color: #31708f;
  background-color: #d9edf7;
  border-color: #faebcc
}

.literalblock pre,
.listingblock > .content > pre {
  border: $pre-border-size $pre-border-style $pre-border-color;
  @include border-radius(4px);
  // set overflow-x just in case content refuses to break
  overflow-x: auto;
  // screens below breakpoint
  padding: $pre-padding;
  font-size: $pre-font-size;
}

// NOTE if highlight class is absent or in first position, we know source highlighter is not active
.literalblock pre,
.listingblock > .content > pre:not(.highlight),
.listingblock > .content > pre[class="highlight"],
.listingblock > .content > pre[class^="highlight "] {
  background: $pre-bg;
}

.literalblock.output pre {
  // FIXME this doesn't work if pre-bg is an image!
  color: $pre-bg;
  background-color: $pre-font-color;
}

.listingblock > .content {
  // give floating language text a place to drop anchor
  position: relative;
}

.listingblock code[data-lang]:before {
  display: none;
  content: attr(data-lang);
  position: absolute;
  font-size: 12px;
  //top: 0.5rem; // 0.67em
  top: 0.425rem;
  right: 0.5rem; // 0.67em
  line-height: 1;
  text-transform: uppercase;
  color: inherit;
  opacity: 0.5;
}

.listingblock:hover code[data-lang]:before {
  display: block;
}

.listingblock.terminal pre .command:before {
  content: attr(data-prompt); 
  padding-right: 0.5em;
  color: inherit;
  opacity: 0.5;
}

.listingblock.terminal pre .command:not([data-prompt]):before {
  content: "$"; 
}

// highlight.js themes put bg on <code>, so shift padding
.listingblock pre.highlightjs {
  padding: 0;
  > code {
    padding: $pre-padding;
    @include border-radius(4px);
  }
}

// overrides for built-in prettify styles
@if not $pre-border-size {
  .listingblock pre.prettyprint {
    border-width: 0;
  }
}

// NOTE set the lowest priority background color in case prettify style doesn't provide one
.prettyprint {
  background: $pre-bg;
}

pre.prettyprint .linenums {
  line-height: $pre-line-height;
  margin-left: 2em;
}

pre.prettyprint li {
  background: none;
  list-style-type: inherit;
  padding-left: 0;
}

pre.prettyprint li code[data-lang]:before {
  opacity: 1;
}

pre.prettyprint li:not(:first-child) code[data-lang]:before {
  display: none;
}
  
// AsciiDoc built-in roles
div.unbreakable {
  page-break-inside: avoid;
}

.big {
  font-size: larger;
}

.small {
  font-size: smaller;
}

@each $decoration in (underline, overline, line-through) {
  .#{$decoration} {
    text-decoration: $decoration;
  }
}
